
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscriptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.create(
            {
                id: data.id || undefined,
        
        provider: data.provider
        ||
        null
            ,
            
        provider_subscription_ref: data.provider_subscription_ref
        ||
        null
            ,
            
        tier: data.tier
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        current_period_start_at: data.current_period_start_at
        ||
        null
            ,
            
        current_period_end_at: data.current_period_end_at
        ||
        null
            ,
            
        cancel_at_period_end: data.cancel_at_period_end
        ||
        false
        
            ,
            
        canceled_at: data.canceled_at
        ||
        null
            ,
            
        price_ref: data.price_ref
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await subscriptions.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return subscriptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const subscriptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                provider: item.provider
            ||
            null
            ,
            
                provider_subscription_ref: item.provider_subscription_ref
            ||
            null
            ,
            
                tier: item.tier
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                current_period_start_at: item.current_period_start_at
            ||
            null
            ,
            
                current_period_end_at: item.current_period_end_at
            ||
            null
            ,
            
                cancel_at_period_end: item.cancel_at_period_end
            ||
            false
        
            ,
            
                canceled_at: item.canceled_at
            ||
            null
            ,
            
                price_ref: item.price_ref
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const subscriptions = await db.subscriptions.bulkCreate(subscriptionsData, { transaction });

        // For each item created, replace relation files
        

        return subscriptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const subscriptions = await db.subscriptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.provider !== undefined) updatePayload.provider = data.provider;
        
        
        if (data.provider_subscription_ref !== undefined) updatePayload.provider_subscription_ref = data.provider_subscription_ref;
        
        
        if (data.tier !== undefined) updatePayload.tier = data.tier;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.current_period_start_at !== undefined) updatePayload.current_period_start_at = data.current_period_start_at;
        
        
        if (data.current_period_end_at !== undefined) updatePayload.current_period_end_at = data.current_period_end_at;
        
        
        if (data.cancel_at_period_end !== undefined) updatePayload.cancel_at_period_end = data.cancel_at_period_end;
        
        
        if (data.canceled_at !== undefined) updatePayload.canceled_at = data.canceled_at;
        
        
        if (data.price_ref !== undefined) updatePayload.price_ref = data.price_ref;
        
        
        updatePayload.updatedById = currentUser.id;

        await subscriptions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await subscriptions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return subscriptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of subscriptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of subscriptions) {
                await record.destroy({transaction});
            }
        });


        return subscriptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findByPk(id, options);

        await subscriptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await subscriptions.destroy({
            transaction
        });

        return subscriptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findOne(
            { where },
            { transaction },
        );

        if (!subscriptions) {
            return subscriptions;
        }

        const output = subscriptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await subscriptions.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.provider) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'provider',
                        filter.provider,
                    ),
                };
            }
            
            if (filter.provider_subscription_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'provider_subscription_ref',
                        filter.provider_subscription_ref,
                    ),
                };
            }
            
            if (filter.price_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'price_ref',
                        filter.price_ref,
                    ),
                };
            }
            

            
            

            
            if (filter.current_period_start_atRange) {
                const [start, end] = filter.current_period_start_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_start_at: {
                    ...where.current_period_start_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_start_at: {
                    ...where.current_period_start_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_period_end_atRange) {
                const [start, end] = filter.current_period_end_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.canceled_atRange) {
                const [start, end] = filter.canceled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.tier) {
                where = {
                    ...where,
                tier: filter.tier,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.cancel_at_period_end) {
                where = {
                    ...where,
                cancel_at_period_end: filter.cancel_at_period_end,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.subscriptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'subscriptions',
                        'provider_subscription_ref',
                        query,
                    ),
                ],
            };
        }

        const records = await db.subscriptions.findAll({
            attributes: [ 'id', 'provider_subscription_ref' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_subscription_ref', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_subscription_ref,
        }));
    }

    
};

